; Source created with Parsic Version 3.x

; at              : 28.05.2005 13:27:26


; Project File    : C:\Programme\parsic\Parsic_3.4.3.w.CR\test.PIC

; Project Version : 1.0.0

; Created         : 28.05.2005 13:05:18

; Last change     : 28.05.2005 13:19:22

	PROCESSOR 16F627

	INCLUDE P16F627.INC

	RADIX DEC


	__IDLOCS H'0100'

	__CONFIG _CP_OFF & _PWRTE_ON & _WDT_ON & _BODEN_ON & _XT_OSC & _LVP_OFF & _MCLRE_ON

; Diverses

ZERO	EQU Z	; ZERO-Flag
CARRY	 EQU C	; CARRY-Flag


; Variable

TR1	= 32	; located in Bank 0
TR1_HI	= 33	; located in Bank 0
S0	= 34	; located in Bank 0
TR2	= 35	; located in Bank 0
TR2_HI	= 36	; located in Bank 0
TR3	= 37	; located in Bank 0
TR3_HI	= 38	; located in Bank 0
TR4	= 39	; located in Bank 0
TR4_HI	= 40	; located in Bank 0
RAM	= 41	; located in Bank 0
SYS_WSAV	= 112	; located in Bank 0, 1, 2, 3
SYS_SSAV	= 113	; located in Bank 0, 1, 2, 3

	ERRORLEVEL -302	; disable warning (Bankswitching)
	ERRORLEVEL -306	; disable warning (Pageswitching)

;****************************************
;Programmanfang
;****************************************

	ORG 0

	CLRF STATUS	; switch to RAM-Bank 0
	GOTO SYS_INIT
	NOP
	NOP

;****************************************
;Interrupt-Adress
;****************************************

	MOVWF SYS_WSAV	; save register
	SWAPF STATUS,W
	CLRF STATUS	; bank 0
	MOVWF SYS_SSAV

	BCF INTCON,T0IF	; Interrupt quitieren

	INCFSZ TR1,F
	GOTO SYS_INT_LABEL_0
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	INCF TR1_HI,F

SYS_INT_LABEL_0
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	INCFSZ TR2,F
	GOTO SYS_INT_LABEL_1
	INCF TR2_HI,F

SYS_INT_LABEL_1
	BSF STATUS,RP0	; Bank 1
	INCFSZ TR3,F
	GOTO SYS_INT_LABEL_2
	INCF TR3_HI,F

SYS_INT_LABEL_2
	BCF STATUS,RP0	; Bank 2
	BSF STATUS,RP1	; Bank 2
	INCFSZ TR4,F
	GOTO SYS_INT_LABEL_3
	INCF TR4_HI,F

SYS_INT_LABEL_3

EXITINT

	SWAPF SYS_SSAV,W	; Register zurck
	MOVWF STATUS
	SWAPF SYS_WSAV,F
	SWAPF SYS_WSAV,W

	RETURN


;****************************************
; Subroutines
;****************************************


;****************************************
;Initialisierung
;****************************************


SYS_INIT

	MOVLW B'00100000'
	MOVWF INTCON

; Set output before direction

	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	MOVLW B'00000000'
	MOVWF PORTA

	MOVLW B'00000000'
	MOVWF PORTB

	MOVLW 143
	BSF STATUS,RP0	; Bank 1
	MOVWF OPTION_REG


; Richtung setzen

	MOVLW B'11111111'
	MOVWF TRISA

	MOVLW B'11110000'
	MOVWF TRISB

	MOVLW 7	; Comparators off
	MOVWF CMCON
; init vars


; Clear RAM

	BCF STATUS,IRP
	MOVLW 32
	MOVWF FSR
CR1
	CLRF INDF
	INCF FSR,F
	BTFSS FSR,7
	GOTO CR1
	BSF FSR,5
CR2
	CLRF INDF
	INCF FSR,F
	MOVLW H'F0'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR2
	BSF STATUS,IRP
	MOVLW 32
	MOVWF FSR
CR3
	CLRF INDF
	INCF FSR,F
	MOVLW H'50'
	SUBWF FSR,W
	BTFSS STATUS,ZERO
	GOTO CR3


	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	CLRF TMR0
	BCF INTCON,T0IF
	BSF INTCON,GIE	; Interrupt freigeben

;**********************************
;******* Haupt-Programm ***********
;**********************************

MAIN

	CLRWDT

;***************************************************
; Timer -> TR1
;***************************************************

	MOVLW 3	; Test auf >=
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	SUBWF TR1_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR1_CHECK
	MOVLW 209
	SUBWF TR1,W	;F-W -> W
LABEL_TR1_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR1_ENDE

LABEL_TR1_RESET
	MOVLW 3	; Test auf >=
	BSF STATUS,RP0	; Bank 1
	SUBWF TR1_HI,F	;F-W -> F
	MOVLW 209
	SUBWF TR1,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR1_HI,F

LABEL_TR1_SET	; toggel output
	BTFSC S0,0
	GOTO LABEL_TR1_CLR
	BSF S0,0
	GOTO LABEL_TR1_ENDE
LABEL_TR1_CLR
	BCF S0,0
LABEL_TR1_ENDE

;***************************************************
; UND - Gatter -> LG1
;***************************************************

LABEL_LG1_1
	BTFSS S0,0
	GOTO LABEL_LG1_FALSE
LABEL_LG1_2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS PORTA,0
	GOTO LABEL_LG1_FALSE

LABEL_LG1_TRUE
	BSF STATUS,RP0	; Bank 1
	BSF PORTB,0
	GOTO LABEL_LG1_ENDE
LABEL_LG1_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,0
LABEL_LG1_ENDE
;***************************************************
; Timer -> TR2
;***************************************************

	MOVLW 7	; Test auf >=
	SUBWF TR2_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR2_CHECK
	MOVLW 161
	SUBWF TR2,W	;F-W -> W
LABEL_TR2_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR2_ENDE

LABEL_TR2_RESET
	MOVLW 7	; Test auf >=
	SUBWF TR2_HI,F	;F-W -> F
	MOVLW 161
	SUBWF TR2,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR2_HI,F

LABEL_TR2_SET	; toggel output
	BTFSC S0,1
	GOTO LABEL_TR2_CLR
	BSF S0,1
	GOTO LABEL_TR2_ENDE
LABEL_TR2_CLR
	BCF S0,1
LABEL_TR2_ENDE

;***************************************************
; Timer -> TR3
;***************************************************

	MOVLW 15	; Test auf >=
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	SUBWF TR3_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR3_CHECK
	MOVLW 66
	BSF STATUS,RP0	; Bank 1
	SUBWF TR3,W	;F-W -> W
LABEL_TR3_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR3_ENDE

LABEL_TR3_RESET
	MOVLW 15	; Test auf >=
	SUBWF TR3_HI,F	;F-W -> F
	MOVLW 66
	SUBWF TR3,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR3_HI,F

LABEL_TR3_SET	; toggel output
	BTFSC S0,3
	GOTO LABEL_TR3_CLR
	BSF S0,3
	GOTO LABEL_TR3_ENDE
LABEL_TR3_CLR
	BCF S0,3
LABEL_TR3_ENDE

;***************************************************
; Timer -> TR4
;***************************************************

	MOVLW 38	; Test auf >=
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	SUBWF TR4_HI,W	;F-W -> W
	BTFSS STATUS,ZERO
	GOTO LABEL_TR4_CHECK
	MOVLW 38
	BSF STATUS,RP1	; Bank 2
	SUBWF TR4,W	;F-W -> W
LABEL_TR4_CHECK
	BTFSS STATUS,CARRY
	GOTO LABEL_TR4_ENDE

LABEL_TR4_RESET
	MOVLW 38	; Test auf >=
	SUBWF TR4_HI,F	;F-W -> F
	MOVLW 38
	SUBWF TR4,F	;F-W -> F
	BTFSS STATUS,CARRY
	DECF TR4_HI,F

LABEL_TR4_SET	; toggel output
	BTFSC S0,2
	GOTO LABEL_TR4_CLR
	BSF S0,2
	GOTO LABEL_TR4_ENDE
LABEL_TR4_CLR
	BCF S0,2
LABEL_TR4_ENDE

;***************************************************
; UND - Gatter -> LG2
;***************************************************

LABEL_LG2_1
	BTFSS S0,1
	GOTO LABEL_LG2_FALSE
LABEL_LG2_2
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BTFSS PORTA,1
	GOTO LABEL_LG2_FALSE

LABEL_LG2_TRUE
	BSF STATUS,RP0	; Bank 1
	BSF PORTB,1
	GOTO LABEL_LG2_ENDE
LABEL_LG2_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,1
LABEL_LG2_ENDE
;***************************************************
; UND - Gatter -> LG3
;***************************************************

LABEL_LG3_1
	BTFSS S0,3
	GOTO LABEL_LG3_FALSE
LABEL_LG3_2
	BSF STATUS,RP0	; Bank 1
	BTFSS PORTA,2
	GOTO LABEL_LG3_FALSE

LABEL_LG3_TRUE
	BSF PORTB,2
	GOTO LABEL_LG3_ENDE
LABEL_LG3_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,2
LABEL_LG3_ENDE
;***************************************************
; UND - Gatter -> LG4
;***************************************************

LABEL_LG4_1
	BTFSS S0,2
	GOTO LABEL_LG4_FALSE
LABEL_LG4_2
	BSF STATUS,RP0	; Bank 1
	BTFSS PORTA,3
	GOTO LABEL_LG4_FALSE

LABEL_LG4_TRUE
	BSF PORTB,3
	GOTO LABEL_LG4_ENDE
LABEL_LG4_FALSE
	BCF STATUS,RP0	; Bank 0
	BCF STATUS,RP1	; Bank 0
	BCF PORTB,3
LABEL_LG4_ENDE
;****************************************

	GOTO MAIN


	END

